//+------------------------------------------------------------------+
//|                                              MTF_FractalsMod.mq4 |
//|                                                        avoitenko |
//|                        https://login.mql5.com/en/users/avoitenko |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "https://login.mql5.com/en/users/avoitenko"

#property indicator_chart_window

//--- indicator settings
#property indicator_buffers 2

#property indicator_color1 Red
#property indicator_color2 Blue

#property indicator_width1 2
#property indicator_width2 2

//+------------------------------------------------------------------+
//| Inputs                                                           |
//+------------------------------------------------------------------+
extern int TimeFrame     = PERIOD_H1;
extern int leftbars      = 10;
extern int rightbars     = 10;
extern int shift         = 0;

//--- indicator buffers
double ExtUpperBuffer[];
double ExtLowerBuffer[];
double CalcBuffer[];

//--- global vars
bool returnBars;
bool calculateValue;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   
   if(TimeFrame>0 && TimeFrame<Period())TimeFrame=Period();
   
   SetIndexBuffer(0, ExtUpperBuffer);
   SetIndexBuffer(1, ExtLowerBuffer);
   SetIndexBuffer(2, CalcBuffer);
   
   SetIndexStyle(0, DRAW_ARROW, 0, 0);
   SetIndexStyle(1, DRAW_ARROW, 0, 0);
   
   SetIndexLabel(0, "Fractal Up");
   SetIndexLabel(1, "Fractal Down");
   
   SetIndexArrow(0, 234);
   SetIndexArrow(1, 233);

   returnBars        = (TimeFrame == -1);
   calculateValue    = (TimeFrame == -2);

   IndicatorDigits(Digits);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   
   int i,j;
   int limit;
   int countup=0;
   int countdown=0;
//--- no data, then exit
   if(Bars < leftbars+rightbars+1) return(0);
   
//---
   if(counted_bars==0)
     {
      limit = Bars - leftbars;
      //--- clean up arrays
      ArrayInitialize(ExtUpperBuffer,0);
      ArrayInitialize(ExtLowerBuffer,0);
     }
   else
      limit=Bars - counted_bars + rightbars + 1;
   
   //--- return bars count
   if(returnBars){CalcBuffer[0] = limit; return(0);}   

//--- calculate on current tf
   if (calculateValue || TimeFrame==Period() ||  TimeFrame == 0)
   {      	

      for(i=limit;i>=0;i--)
        {
         for(j=1;j<=leftbars;j++)
           {
            if(High[i]>High[i+j]) countup=countup+1;
            if(Low[i]<Low[i+j]) countdown=countdown+1;
           }
         for(j=1;j<=rightbars;j++)
           {
            if(High[i]>High[i-j]) countup=countup+1;
            if(Low[i]<Low[i-j]) countdown=countdown+1;
           }
         if(countup==leftbars+rightbars) ExtUpperBuffer[i-shift]=High[i];
         else ExtUpperBuffer[i-shift]=ExtUpperBuffer[i-shift+1];
      
         if(countdown==leftbars+rightbars) ExtLowerBuffer[i-shift]=Low[i];
         else ExtLowerBuffer[i-shift]=ExtLowerBuffer[i-shift+1];
      
         countup=0;
         countdown=0;
        }

      return(0);   
   }
   //--- MTF mode
   
   //--- get bars
   int bars = iCustom(NULL,TimeFrame,WindowExpertName(),-1,1,0)*TimeFrame/Period();
   limit = MathMax(limit,MathMin(Bars-1,bars));
   
   //--- calculate
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      //--- recursive call
      ExtUpperBuffer[i] = iCustom(NULL,TimeFrame,WindowExpertName(),-2,leftbars,rightbars,shift,0,y);
      ExtLowerBuffer[i] = iCustom(NULL,TimeFrame,WindowExpertName(),-2,leftbars,rightbars,shift,1,y);
   }              

   return(0);
  }
//+------------------------------------------------------------------+

